#ifndef CRUFSM_H
#define CRUFSM_H

#include "fsm/MStreamDeviceMgrFsm.h"

#include "base/RcRunId.h"

struct CruFsmInput : public MStreamDeviceMgrFsmInput
{
    QMap<DeviceIndex, RcRunId> devRunId;
    RcRunId runId;
};

class CruFsm : public MStreamDeviceMgrFsm
{
    Q_OBJECT
public:
    explicit CruFsm(QObject *parent = nullptr);
    virtual bool isTransitionAllowed(const FsmState &toState) const override;

public slots:
    void setRunId(RcRunId runId);
    void setDevRunId(const DeviceIndex &index, RcRunId runId);

protected:
    virtual void printInputString(QDebug dbg) const override;
    virtual qint64 stateTimeoutMs(const FsmState &state) const override;
    inline CruFsmInput *getInput() {
        return static_cast<CruFsmInput*>(BaseFsm::getInput());
    }
    inline const CruFsmInput *getInput() const {
        return static_cast<const CruFsmInput*>(BaseFsm::getInput());
    }

    bool allDevPreRunReseted() const;
};

QDebug operator<<(QDebug dbg, const CruFsmInput &in);

#endif // CRUFSM_H
