#ifndef FILEREADER_H
#define FILEREADER_H

#include <QObject>
#include <QByteArray>

#include "FileWatcherConfig.h"

class QFileSystemWatcher;

class FileReader : public QObject
{
    Q_OBJECT
public:
    FileReader(QObject *parent);

public slots:
    void setConfig(const FileWatcherConfig &newConfig);
    void setEnabled(bool en);

signals:
    void fileDataUpdate(const QByteArray &data) const;
    void fileValidUpdate(bool valid) const;
    void configChanged(const FileWatcherConfig &config) const;

private slots:
    void checkFile();

private:
    FileWatcherConfig cfg;
    bool enabled = false;
    QByteArray lastFileData;
    QFileSystemWatcher * const fileWatcher;
};

#endif // FILEREADER_H
