#include "FileWatcherApp.h"

#include <QCommandLineParser>
#include <QCoreApplication>

FileWatcherApp::FileWatcherApp(int &_argc, char *_argv[])
    : DaqCoreApp(_argc, _argv)
    , filePathOption(QStringList() << "f" << "filePath",
                     QCoreApplication::translate("filePath", "path for T0 configuration file"),
                     "[filePath]")
{
}

void FileWatcherApp::setupOptions()
{
    DaqCoreApp::setupOptions();
    options << filePathOption;

}

void FileWatcherApp::processParseResults(QCommandLineParser &parser)
{
    DaqCoreApp::processParseResults(parser);

    so.path = parser.value(filePathOption);
}
