#ifndef TRIGGERSETUPDIALOG_H
#define TRIGGERSETUPDIALOG_H

#include <QDialog>
#include <QMap>

class ConfigKey;
class HrbTriggerSetup;
class QCheckBox;

namespace Ui {
class TriggerSetupDialog;
}

class TriggerSetupDialog : public QDialog
{
    Q_OBJECT

public:
    explicit TriggerSetupDialog(QWidget *parent = 0);
    ~TriggerSetupDialog();
    void setControlEnable(bool en);

    // ===== HrbTriggerSetup begin =====
signals:
    void hrbTriggerSetupChanged(const HrbTriggerSetup &) const;
public slots:
    void setTriggerSetup(const ConfigKey &, const HrbTriggerSetup &setup);
    // ===== HrbTriggerSetup end  =====

private slots:
    void on_spinBoxInterval_valueChanged(int arg1);
    void sendSetup() const;

private:
    HrbTriggerSetup getSetup() const;
    Ui::TriggerSetupDialog *ui;
    uint blockControl = 0;

    QMap<QCheckBox*, bool HrbTriggerSetup:: *> map;
};

#endif // TRIGGERSETUPDIALOG_H
