#include "MongoViewerConfigConverter.h"

#include "MongoViewerConfig.h"

template<>
bool AbstractConfigConverter<MongoViewerConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<MongoViewerConfig>::toJsonObject(const MongoViewerConfig &in)
{
    QVariantMap m;
    m["rows_on_page"] = QVariant::fromValue(in.rows_on_page);
    m["page_number"] = QVariant::fromValue(in.page_number);
    return fromVariantMap(m);
}

template<>
MongoViewerConfig AbstractConfigConverter<MongoViewerConfig>::fromJsonObject(const QJsonObject &m)
{
    MongoViewerConfig out;
    out.rows_on_page = QVariant::fromValue(m["rows_on_page"]).value<int>();
    out.page_number = QVariant::fromValue(m["page_number"]).value<int>();
    return out;
}

template<>
QJsonValue AbstractConfigConverter<MongoViewerConfig>::toJsonValue(const MongoViewerConfig &in)
{
    return toJsonObject(in);
}

template<>
MongoViewerConfig AbstractConfigConverter<MongoViewerConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<MongoViewerConfig>::registerSubTypes()
{}
