#ifndef FILEWRITERSTATS_H
#define FILEWRITERSTATS_H

#include <QMetaType>
#include <QElapsedTimer>

struct FileWriterStats {
    FileWriterStats() { clear(); }
    void clear() {
        writtenFileSize = 0;
        writtenTotalSize = 0;
        missedFileSize = 0;
        fileName.clear();
        predefStorage.clear();
    }

    quint64 writtenFileSize;
    quint64 writtenTotalSize;
    quint64 missedFileSize;
    QString fileName;
    QString predefStorage;
    QElapsedTimer timeStamp;
    int rbSize = 0;
    double dataPart = 0;
};
Q_DECLARE_METATYPE(FileWriterStats)

#endif // FILEWRITERSTATS_H
