#ifndef TLU40LVDSMODELITEM_H
#define TLU40LVDSMODELITEM_H

#include "base/DeviceIndex.h"

struct Tlu40LvdsModelItem
{
    explicit Tlu40LvdsModelItem() = default;
    ~Tlu40LvdsModelItem() {
        qDeleteAll(children);
    }

    Tlu40LvdsModelItem *child(int row) const { return children.value(row, nullptr); }
    Tlu40LvdsModelItem *createChild() {
        auto child = new Tlu40LvdsModelItem();
        child->dev = dev;
        child->mod = mod;
        child->ch = ch;
        child->isTof = isTof;
        child->isLum = isLum;
        child->parent = this;
        children.push_back(child);
        return child;
    }
    int childCount() const { return children.size();}
    int row() const {
        if(parent)
            return parent->children.indexOf(const_cast<Tlu40LvdsModelItem*>(this));
        return 0;
    }

    DeviceIndex dev;
    bool isTof = false;
    bool isLum = false;
    int mod=-1;
    int ch=-1;
    Tlu40LvdsModelItem *parent = nullptr;
    QVector<Tlu40LvdsModelItem *> children;
};
#endif // TLU40LVDSMODELITEM_H
