#include "MscHistDialog.h"
#include "ui_MscHistDialog.h"

#include <QTreeView>

#include "MscHistModel.h"

MscHistDialog::MscHistDialog(QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::MscHistDialog)
{
    ui->setupUi(this);

    connect(ui->pushButtonDefCh, &QAbstractButton::clicked,
            this, &MscHistDialog::resetConfigHistCh);

    connect(ui->buttonBox, &QDialogButtonBox::accepted,
            this, &MscHistDialog::hide);
}

MscHistDialog::~MscHistDialog()
{
    delete ui;
}

void MscHistDialog::setModel(MscHistModel *model)
{
    ui->treeViewHist->setModel(model);

    connect(model, &QAbstractItemModel::modelReset, [=, this]() {
          auto t = ui->treeViewHist;
          for(int c=0; c<model->columnCount(); ++c)
              t->resizeColumnToContents(c);
          t->expandAll();
    });
}
