#ifndef MSCSPINBOXDELEGATE_H
#define MSCSPINBOXDELEGATE_H

#include  "MscBaseDelegate.h"

class QSpinBox;

struct SpinBoxParams
{
    int step=1;
    int base=10;
    int max=65535;
    int min=0;
    bool groupSeparator = true;
    QString suffix;
};

class MscSpinBoxDelegate : public MscBaseDelegate
{
Q_OBJECT
public:
    MscSpinBoxDelegate(QObject *parent = nullptr) : MscBaseDelegate(parent) {}
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &model_index) const;
    void setEditorData(QWidget *editor,
                       const QModelIndex &index) const;
    void setModelData(QWidget *editor,
                      QAbstractItemModel *model,
                      const QModelIndex &model_index) const;

protected:
    virtual SpinBoxParams getParams(int col) const = 0;
};

#endif // MSCSPINBOXDELEGATE_H
