/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "PnpBrowserMainWindow.h"
#include "ui_PnpBrowserMainWindow.h"

#include "PNPDiscoverDialog.h"
#include "pnp-server/PnpServerWithStats.h"
#include "pnp-server/PnpServerStats.h"

PnpBrowserMainWindow::PnpBrowserMainWindow(QWidget *parent) :
    BaseMainWindow(parent),
    ui(new Ui::PnpBrowserMainWindow),
    pnpDiscoverDialog(new PNPDiscoverDialog(this))
{
    ui->setupUi(this);
    setupMenu();
    ui->verticalLayout_1->addWidget(pnpDiscoverDialog);

    connect(pnpDiscoverDialog, &QDialog::accepted,
            this, &QMainWindow::close);
    connect(pnpDiscoverDialog, &QDialog::rejected,
            this, &QMainWindow::close);
}

PnpBrowserMainWindow::~PnpBrowserMainWindow()
{
    delete ui;
}

void PnpBrowserMainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void PnpBrowserMainWindow::on_actionShow_sequence_stat_toggled(bool arg1)
{
    pnpDiscoverDialog->show_seq_stat(arg1);
}
