#include "TqdcApp.h"

#include <QCommandLineParser>
#include <QPixmap>

TqdcApp::TqdcApp(int &_argc, char *_argv[])
    : DaqGuiApp(_argc, _argv)
    , telnetPortOption("telnetRcPort", "Set porn number for Troitsk's RemoteControl",
      "telnetRcPort")
{
}

void TqdcApp::setupOptions()
{
    DaqGuiApp::setupOptions();
    options <<telnetPortOption;
}

void TqdcApp::processParseResults(QCommandLineParser &parser)
{
    DaqGuiApp::processParseResults(parser);

    if(parser.isSet(telnetPortOption)) {
        bool ok;
        startupOptions.telnetPort = parser.value(telnetPortOption).toUInt(&ok);
        if(!ok)
            parser.showHelp();
    }
}

QPixmap TqdcApp::getSplashPixmap() const
{
    return QPixmap(":/icons/tqdc2-splash.png");
}
