/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "TqdcDacConverter.h"

double TqdcDacConverter::getDacDefaultZero() const
{
    return 1920;
}

double TqdcDacConverter::getVRef() const
{
    const double DAC_V_REF_TQDC16_THR = 3.3 * 82.5 / (82.5 + 130); // in V (1.2812)
    return DAC_V_REF_TQDC16_THR * 1e3;
}

bool TqdcDacConverter::getGain() const
{
    return false;
}

quint16 TqdcDacConverter::getDacMaxVal() const
{
    return (1<<12) - 1;
}
