#include "TqdcConfigDispatcher.h"

#include "cal/CalConfig.h"
#include "cal/CalResult.h"

TqdcConfigDispatcher::TqdcConfigDispatcher(QObject *parent)
    : ReadoutAppConfigDispatcher(parent)
    , cacheCalConfig(new CalConfig())
{}

void TqdcConfigDispatcher::setCalConfig(const CalConfig &newCalConfig)
{
    if (newCalConfig == *cacheCalConfig)
        return;
    *cacheCalConfig = newCalConfig;
    incrementConfigKey();
}

void TqdcConfigDispatcher::setCalResult(const CalResult &newCalResult)
{
    if (newCalResult == cacheCalConfig->value(newCalResult.index))
        return;
    *cacheCalConfig->insert(newCalResult.index, newCalResult);
    incrementConfigKey();
}

void TqdcConfigDispatcher::sendConfigKeyCache()
{
    BaseConfigDispatcher::sendConfigKeyCache();

    const auto &calConfig = *cacheCalConfig;
    emit calConfigChanged(config_key, calConfig);
    for (const auto &calResult : calConfig)
        emit calResultChanged(config_key, calResult);
}
