#ifndef TTVXSCONFIGDB_H
#define TTVXSCONFIGDB_H

#include "base/DeviceIndexEnabled.h"
#include "lib-common/RunControlAppConfig.h"
#include "mongo/AbstractConfigDb.h"

class ConfigKey;

class TtvxsConfigDb : public AbstractConfigDb
{
    Q_OBJECT
public:
    explicit TtvxsConfigDb(QObject *parent = nullptr);

signals:
    void configChanged(const RunControlAppConfig &config);
    void deviceListChanged(const DeviceIndexEnabledMap &map);

public slots:
    void setConfig(const ConfigKey &config_key, const RunControlAppConfig &newConfig);

protected:
    void update_config_from_db() override;

private:
    RunControlAppConfig config;
    DeviceIndexEnabledMap map;
};

#endif // TTVXSCONFIGDB_H
