#ifndef CALIBRATIONDIALOG_H
#define CALIBRATIONDIALOG_H

#include <QDialog>
#include <QMap>

class DeviceSetup;
class DeviceCalibration;

namespace Ui {
class CalibrationDialog;
}

class CalibrationDialog : public QDialog
{
    Q_OBJECT

public:
    explicit CalibrationDialog(QWidget *parent = nullptr);
    ~CalibrationDialog();

public slots:
    void setChNumber(int num);
    void init(const DeviceCalibration &devCal);
    void updateInl(const QMap<int, QVector<double> > &inlCorr);

private slots:
    void on_pushButtonClose_clicked();

private:
    void initTable();
    void setTableInl(int ch, bool inlOk);

    Ui::CalibrationDialog *ui;
    QMap<int, bool> inlPresent;
    int chNum;
};

#endif // CALIBRATIONDIALOG_H
