/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef ABSTRACTDISPATCHER_H
#define ABSTRACTDISPATCHER_H

#include <QObject>

class AbstractDispatcher : public QObject
{
    Q_OBJECT
public:
    explicit AbstractDispatcher(QObject *parent = nullptr)
        : QObject{parent} {}

    static QString objectPrettyName(const QObject *obj);

protected:
    void logConnection(const QObject *obj, const QString &name, const QString &symbol = "<->") const;

};

#endif // ABSTRACTDISPATCHER_H
