#include "BaseDeviceConfigConverter.h"

#include "BaseDeviceConfig.h"
#include "DeviceIndexConverter.h"

namespace {
constexpr const char *k_enabled = "enabled";
constexpr const char *k_index = "index";
}
// --------- BaseDeviceConfig

template<>
bool AbstractConfigConverter<BaseDeviceConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<BaseDeviceConfig>::toJsonObject(const BaseDeviceConfig &in)
{
    QVariantMap m;

    m[k_enabled] = QVariant::fromValue(in.enabled);
    m[k_index] = QVariant::fromValue(in.index);

    return fromVariantMap(m);
}

template<>
BaseDeviceConfig AbstractConfigConverter<BaseDeviceConfig>::fromJsonObject(const QJsonObject &in)
{
    BaseDeviceConfig out;

    update_value(in, k_enabled, &out.enabled);
    update_value(in, k_index, &out.index);

    return out;
}

template<>
QJsonValue AbstractConfigConverter<BaseDeviceConfig>::toJsonValue(const BaseDeviceConfig &in)
{
    return toJsonObject(in);
}

template<>
BaseDeviceConfig AbstractConfigConverter<BaseDeviceConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<BaseDeviceConfig>::registerSubTypes()
{
    AbstractConfigConverter<DeviceIndex>::registerTypes();
}
