/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef CONFIGSELECTORCONVERTER_H
#define CONFIGSELECTORCONVERTER_H

#include "AbstractConfigConverter.h"
#include "ConfigSelector.h"

inline constexpr const char *k_cs_program_type = "program_type"; // needed for select query in PgDB
inline constexpr const char *k_cs_program_index = "program_index";
inline constexpr const char *k_cs_configuration_name = "configuration_name";

template<>
void AbstractConfigConverter<ConfigSelector>::registerSubTypes();

QJsonValue getJsonCSFromDaqModule(const DaqModule &dm);

#endif // CONFIGSELECTORCONVERTER_H
