/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DaqModuleTraits.h"

bool DaqModuleTraits::hasSerDes(DaqModule::Type t)
{
    static const QList<DaqModule::Type> s {
        DaqModule::Type::Adc64,
        DaqModule::Type::Adc64System,
        DaqModule::Type::PhosFec,
        DaqModule::Type::TQDC
    };
    return s.contains(t);
}

bool DaqModuleTraits::hasHptdc(DaqModule::Type t)
{
    static const QList<DaqModule::Type> s {
        DaqModule::Type::PhosFec,
        DaqModule::Type::TdcControl,
        DaqModule::Type::TQDC
    };
    return s.contains(t);
}

bool DaqModuleTraits::hasFelink(DaqModule::Type t)
{
    static const QList<DaqModule::Type> s {
        DaqModule::Type::Cru,
        DaqModule::Type::TdcControl,
        DaqModule::Type::TQDC,
        DaqModule::Type::Ttvxs
    };
    return s.contains(t);
}

bool DaqModuleTraits::hasMstream(DaqModule::Type t)
{
    static const QList<DaqModule::Type> s {
        DaqModule::Type::Adc64,
        DaqModule::Type::Adc64System,
        DaqModule::Type::HrbSystem,
        DaqModule::Type::Msc16Ve,
        DaqModule::Type::PhosFec,
        DaqModule::Type::Trc,
        DaqModule::Type::TdcControl,
        DaqModule::Type::TQDC,
        DaqModule::Type::Ttvxs,
        DaqModule::Type::T0CfgMonitor
    };
    return s.contains(t);
}
