/*
**    Copyright 2010-2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef WINDOWFUNCTION_H
#define WINDOWFUNCTION_H

#include <QVector>

namespace dsplib {

class WindowFunction
{
public:
    enum fwinf_t : int {
        WF_BARTHANN = 1,
        WF_BARLETT = 2,
        WF_BLACKMAN = 3,
        WF_BLACKMANHARRIS = 4,
        WF_BOHMAN = 5,
        WF_FLATTOP = 6,
        WF_GAUSS_075 = 7,
        WF_GAUSS_050 = 8,
        WF_GAUSS_025 = 9,
        WF_HAMMING = 10,
        WF_HANN = 11,
        WF_NUTTALL = 12,
        WF_RECT = 13,
        WF_TRIANG = 14,
        WF_TUKEY_075 = 15,
        WF_TUKEY_050 = 16,
        WF_TUKEY_025 = 17
    };
    static QVector<double> series();
    static double value(fwinf_t win_type, double i, int m);
};

} // namespace dsplib

#endif // WINDOWFUNCTION_H
