#ifndef CLIENTINDEXTABLEMODEL_H
#define CLIENTINDEXTABLEMODEL_H

#include <QAbstractTableModel>
#include <QObject>
#include <QMap>

class ClientIndex;

class ClientIndexTableModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    explicit ClientIndexTableModel(QObject *parent = nullptr)
        : QAbstractTableModel{parent} {}

//    ClientIndex clientIndexOf(const QModelIndex &index) const;
    virtual ClientIndex clientIndexOf(int row) const = 0;
    virtual int rowOf(const ClientIndex &sourceIndex) const = 0;

    virtual QVariant headerData(int section, Qt::Orientation orientation,
                                int role = Qt::DisplayRole) const override;

protected:
    void invalidateRow(const ClientIndex &clientIndex);
};

#endif // CLIENTINDEXTABLEMODEL_H
