/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "AdcLemoMuxConfigConverter.h"
#include "AdcLemoMuxConfig.h"

constexpr const char *k_out = "out";
constexpr const char *k_in = "in";

template<>
bool AbstractConfigConverter<AdcLemoMuxCtrlConfig>::classIsObject()
{
    return true;
}

template<>
QJsonObject AbstractConfigConverter<AdcLemoMuxCtrlConfig>::toJsonObject(const AdcLemoMuxCtrlConfig &in)
{
    QVariantMap m;
    m[k_out] = QVariant::fromValue(in.out);
    m[k_in] = QVariant::fromValue(in.in);
    return fromVariantMap(m);
}

template<>
AdcLemoMuxCtrlConfig AbstractConfigConverter<AdcLemoMuxCtrlConfig>::fromJsonObject(const QJsonObject &in)
{
    AdcLemoMuxCtrlConfig out;
    update_value(in, k_out, &out.out);
    update_value(in, k_in, &out.in);
    return out;
}

template<>
QJsonValue AbstractConfigConverter<AdcLemoMuxCtrlConfig>::toJsonValue(const AdcLemoMuxCtrlConfig &in)
{
    return toJsonObject(in);
}

template<>
AdcLemoMuxCtrlConfig AbstractConfigConverter<AdcLemoMuxCtrlConfig>::fromJsonValue(const QJsonValue &in)
{
    return fromJsonObject(in.toObject());
}

template<>
void AbstractConfigConverter<AdcLemoMuxCtrlConfig>::registerSubTypes()
{
}
