#ifndef ADCMPDTRIGMODULE_H
#define ADCMPDTRIGMODULE_H

#include <optional>

#include "device-modules/BaseDeviceModule.h"

#include "AdcMpdTrigBuildParams.h"
#include "CrosspointSwitch/CrosspointSwitchModule.h"

class AdcMpdTrigConfig;

class AdcMpdTrigModule : public BaseDeviceModule<AdcMpdTrigModule>
{
public:
    explicit AdcMpdTrigModule(const MregBusInterface &bus);

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const AdcMpdTrigConfig &config);
    std::optional<AdcMpdTrigBuildParams> getBuildParam() const
    {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<AdcMpdTrigBuildParams> buildParams;
    QSharedPointer<CrosspointSwitchModule> crSwMod;
};

#endif // ADCMPDTRIGMODULE_H
