/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "DlnpCalibrationTriggerConfig.h"

#include <QDataStream>
#include <QDebug>

QDebug operator<<(QDebug dbg, const DlnpCalibrationTriggerConfig &s)
{
    dbg << "DlnpCalibrationTriggerConfig{"
        << "en:" << s.en
        << "period:" << s.period
        << "count:" << s.count
        << "offset:" << s.offset
        << "}";
    return dbg;
}

QDataStream &operator<<(QDataStream &out, const DlnpCalibrationTriggerConfig &r)
{
    out
            << r.en
            << r.period
            << r.count
            << r.offset
               ;
    return out;
}

QDataStream &operator>>(QDataStream &in, DlnpCalibrationTriggerConfig &r)
{
    in
            >> r.en
            >> r.period
            >> r.count
            >> r.offset
            ;
    return in;
}
