#ifndef DLNPCALIBRATIONTRIGGERMODULE_H
#define DLNPCALIBRATIONTRIGGERMODULE_H

#include <optional>

#include "DlnpCalibrationTrigger/DlnpCalibrationTriggerBuildParams.h"
#include "device-modules/BaseDeviceModule.h"

class DlnpCalibrationTriggerConfig;
namespace mlink { class RegOpVector; }

class DlnpCalibrationTriggerModule : public BaseDeviceModule<DlnpCalibrationTriggerModule>
{
public:
    explicit DlnpCalibrationTriggerModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();
    virtual void post_init() override;

    std::optional<DlnpCalibrationTriggerBuildParams> getBuildParam() const
    {
        return buildParams;
    }

    bool writeConfig(const DlnpCalibrationTriggerConfig &fir);

private:
    std::optional<DlnpCalibrationTriggerBuildParams> buildParams;
};

#endif // DLNPCALIBRATIONTRIGGERMODULE_H
