#ifndef HITCORESTATUS_H
#define HITCORESTATUS_H

#include <QVector>

class TaiTime;

class HitCoreStatus
{
public:
    friend bool operator==(const HitCoreStatus &, const HitCoreStatus &) = default;
    HitCoreStatus& operator-=(const HitCoreStatus& r);
    friend HitCoreStatus operator-(HitCoreStatus l, const HitCoreStatus& r) { l -= r; return l; }

    bool isValid() const;
    TaiTime taiTime() const;

    quint32 id = 0;
    quint16 nch = 0;
    QVector<quint32> cnt;
    quint64 ts = 0;
    quint64 compState = 0;
};

#endif // HITCORESTATUS_H
