#ifndef MSCHISTCONFIG_H
#define MSCHISTCONFIG_H

#include <QMap>
#include <QMetaType>

struct MscHistLogConfig
{
    friend bool operator==(const MscHistLogConfig &, const MscHistLogConfig &) = default;
    bool logTypeIsLen = false; // log histogram (0 - interval, 1 - length)
};
Q_DECLARE_METATYPE(MscHistLogConfig)

struct MscHistPlotConfig
{
    friend bool operator==(const MscHistPlotConfig &, const MscHistPlotConfig &) = default;

    QString name;
    bool enable = true;
    quint32 plotSlice = 1e3; // in microsec
};
Q_DECLARE_METATYPE(MscHistPlotConfig)

struct MscHistConfig
{
    friend bool operator==(const MscHistConfig &, const MscHistConfig &) = default;

    QMap<int, MscHistLogConfig> log;
    QMap<int, MscHistPlotConfig> plot;
};
Q_DECLARE_METATYPE(MscHistConfig)

QString getMscHistDisplayName(const MscHistConfig &hist, int hId);

#endif // MSCHISTCONFIG_H
