#ifndef MSCHISTSTATUS_H
#define MSCHISTSTATUS_H

#include <QVector>

struct MscHistBuildParams
{
    friend bool operator==(const MscHistBuildParams &, const MscHistBuildParams &) = default;

    quint16 majVer = 0;

    quint32 clockFreq = 0;
    quint16 chNum = 0; // unused yet

    quint32 ramBaseAddrLogHist = 0;
    quint16 ramBitsNumLogHist = 0;
    quint16 regLogHistBase = 0;
    quint16 logHistNum = 0;

    quint32 ramBaseAddrPlotHist = 0;
    quint16 ramBitsNumHistPlot = 0;
    quint16 regPlotHistBase = 0;
    quint16 regPlotHistMask = 0;
    quint16 plotHistNum = 0;
};

struct MscHistChStatus
{
    friend bool operator==(const MscHistChStatus &, const MscHistChStatus &) = default;
    bool isV2 = false;
    quint32 plot_current_ram_address = 0;
    quint32 plot_last_ram_addr_gate = 0;
    quint32 plot_last_ram_addr_cycle = 0;
    quint32 gate_num = 0;
};

struct MscHistStatus
{
    friend bool operator==(const MscHistStatus &, const MscHistStatus &) = default;
    QVector<MscHistChStatus> chSt;
};

#endif // MSCHISTSTATUS_H
