/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef RUNLOGICCONFIG_H
#define RUNLOGICCONFIG_H

#include <QMetaType>

class RunLogicConfig
{
public:
    friend bool operator==(const RunLogicConfig &, const RunLogicConfig &) = default;
    bool isEventLimit() const { return eventLimitEnable && eventLimit; }
    bool isTimeLimit() const { return timeLimitEnable && timeLimit; }
    bool isAnyLimit() const { return isEventLimit() || isTimeLimit(); }

    bool timeLimitEnable = false;
    bool eventLimitEnable = false;
    uint32_t timeLimit = 1000; // in ms
    uint32_t eventLimit = 1;
};

Q_DECLARE_METATYPE(RunLogicConfig)

#endif // RUNLOGICCONFIG_H
