#ifndef TLUDECDESMODULE_H
#define TLUDECDESMODULE_H

#include "device-modules/BaseDeviceModule.h"

#include <optional>

#include "TluDecDesConfig.h"
#include "TluDecDesStatus.h"
#include "TluDecDesBuildParams.h"

class TluDecDesModule : public BaseDeviceModule<TluDecDesModule>
{
public:
    explicit TluDecDesModule(const MregBusInterface &bus) : BaseDeviceModule(bus) {}

    static QList<AFI_SDB_ID> getSupportedSdbIds();

    bool writeConfig(const TluDecDesConfig &config);
    std::optional<TluDecDesStatus> readStatus();
    std::optional<TluDecDesBuildParams> getBuildParam() const
    {
        return buildParams;
    }

protected:
    void post_init() override;

private:
    std::optional<TluDecDesBuildParams> buildParams;

};

#endif // TLUDECDESMODULE_H
