/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "RegWrTimeTai.h"
#include "TrigInfoStatus.h"
#include "base/TaiTime.h"
#include "sdb/AfiSdbId.h"

static const quint32 STATUS_BIT_VALID = 0x1;

bool TrigInfoStatus::isValid() const
{
    return (id == AFI_SDB_TRIG_INFO) && (status & STATUS_BIT_VALID);
}

TaiTime TrigInfoStatus::timestamp() const
{
    return RegWrTaiTime::fromRaw(ts);
}
