#ifndef ADCCLKSTATUS_H
#define ADCCLKSTATUS_H

#include <QMap>
#include <QMetaType>

#include "device-modules/DeserializersControl/AdcSerDesDelay.h"

struct AdcClkStatus {
    struct WPoint {
        int x; // dataDelay
        int y; // clockDelay
        double weight;
        bool status;
    };

    WPoint getOptimalDelays(int adcId = -1) const;
    static AdcClkStatus aggregate(QList<AdcClkStatus> statusList);
    QString toString() const;
    static QString getLegend();
    AdcSerDesDelayMap getDevDelay() const;

    QMap<int, QMap<int, QMap<int, bool > > > data; // delayStatus <adcId, <clockDelay, <dataDelay, isOk> > >
    double temp = 0;
    QString fwStr;
};
Q_DECLARE_METATYPE(AdcClkStatus)

#endif // ADCCLKSTATUS_H
