#include "SingleSerDesDelayWidget.h"
#include "ui_SingleSerDesDelayWidget.h"

#include "device-modules/DeserializersControl/AdcSerDesDelay.h"

SingleSerDesDelayWidget::SingleSerDesDelayWidget(int _id, QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::SingleSerDesDelayWidget)
    , id(_id)
{
    ui->setupUi(this);
    ui->label->setText(QString("ADC #%1").arg(id+1));
}

SingleSerDesDelayWidget::~SingleSerDesDelayWidget()
{
    delete ui;
}

AdcSerDesDelay SingleSerDesDelayWidget::getDelay() const
{
    return {ui->spinBoxClock->value(), ui->spinBoxData->value()};
}

void SingleSerDesDelayWidget::setDelay(const AdcSerDesDelay &delay)
{
    ui->spinBoxClock->blockSignals(true);
    ui->spinBoxData->blockSignals(true);
    ui->spinBoxClock->setValue(delay.clock);
    ui->spinBoxData->setValue(delay.data);
    ui->spinBoxClock->blockSignals(false);
    ui->spinBoxData->blockSignals(false);
}

void SingleSerDesDelayWidget::setControlEnabled(bool en)
{
    ui->spinBoxClock->setEnabled(en);
    ui->spinBoxData->setEnabled(en);
}

void SingleSerDesDelayWidget::on_spinBoxClock_valueChanged(int val)
{
    emit clockUpdated(id, val);
}

void SingleSerDesDelayWidget::on_spinBoxData_valueChanged(int val)
{
    emit dataUpdated(id, val);
}
