#ifndef HPTDCSTATUSMETRICS_H
#define HPTDCSTATUSMETRICS_H

class QString;

class HptdcStatusMetrics{
public:
    enum class Metric{
        Default,
        VernierError, CoarseError, ChannelSelectError, L1BufParityError, TriggerFIFOParityError,
        TriggerMatchingStateError, ReadoutFIFOParityError, ReadoutStateError,
        SetupParityError, ControlParityError,
        JtagInstructionError, TdcHaveReadoutToken, ReadoutFIFOFull,
        ReadoutFIFOEmpty, TriggerFIFOFull, TriggerFIFOEmpty,
        ReadoutFIFOOccupancy, TriggerFIFOOccupancy, DllLock, InvertedSetupBit601,
        OccupancyOfL1BufferOfChannelGroup0, OccupancyOfL1BufferOfChannelGroup1,
        OccupancyOfL1BufferOfChannelGroup2, OccupancyOfL1BufferOfChannelGroup3
    };
    explicit HptdcStatusMetrics(const Metric metric = Metric::Default) : metric(metric) {}
    operator Metric() const { return metric; }
    Metric getMetric() const { return metric; }
    QString toString() const;
    void setMetric(Metric metric_);

private:
    Metric metric = Metric::Default;
};

#endif // HPTDCSTATUSMETRICS_H
