#ifndef FPGADATABASE_H
#define FPGADATABASE_H

#include <QDateTime>
#include <QObject>
#include <QSqlDatabase>

enum {
    DB_STATUS_OK = 0,
    DB_STATUS_ERROR = 1,
};

class FpgaDataBase : public QObject
{
    Q_OBJECT

    struct Record
    {
        uint id;
        QString serialHexStr;
        QString dateStr;
        bool isGold;

        bool isGit = false;
        int fw_maj;
        int fw_min;
        uint revision;
        QString git_hash;

        QString fileName;
        QString filePath;
    };

public:
    explicit FpgaDataBase(QWidget *parent = nullptr);
    bool getDataBaseStatus();
    QSqlError getLastDbError();
    QString toString();

public slots:
    void writeInfo(const quint64 &serial, bool isGold, QString imgPath);
    void readInfo(quint64 devSerial);

Q_SIGNALS:
    void setStatus(const QString &status, const int &level);

private:
    QDateTime getRecordTimeStamp(const int &id);
    QSqlDatabase getConnection();

    QString selectedConnection;
};

#endif // FPGADATABASE_H
