#include "DeviceData.h"

static constexpr const auto HPTDC_TS_STEP_NS = 0.024 / 1.024;

double TdcChHit::getLeadTimeNs(const QVector<double> &inlCorr)
{
    if (hasLeadTimeInl)
        return leadTimeInl;
    hasLeadTimeInl = true;
    return leadTimeInl = HPTDC_TS_STEP_NS * (inlCorr.value(leadingTime % 1024, 0) + leadingTime);
}

double TdcChHit::getTrailTimeNs(const QVector<double> &inlCorr)
{
    if (hasTrailTimeInl)
        return trailTimeInl;
    hasTrailTimeInl = true;
    return trailTimeInl = HPTDC_TS_STEP_NS * (inlCorr.value(trailingTime % 1024, 0) + trailingTime);
}

double TdcChHit::getHitTime(const QVector<double> &inlCorr)
{
    return leadingTime ? getLeadTimeNs(inlCorr) : getTrailTimeNs(inlCorr);
}

double TdcChHit::getWidthNs(const QVector<double> &inlCorr)
{
    if (hasWidthTimeInl)
        return widthTimeInl;
    hasWidthTimeInl = true;
    return widthTimeInl = (getTrailTimeNs(inlCorr) - getLeadTimeNs(inlCorr));
}
