#ifndef JSONMODEL_H
#define JSONMODEL_H

#include <QAbstractItemModel>

class QJsonObject;

class JsonTreeItem;

class JsonTreeModel : public QAbstractItemModel
{
Q_OBJECT
protected:
    enum JSON_MODEL_COL {
        JSON_MODEL_COL_KEY,
        JSON_MODEL_COL_VAL,
        JSON_MODEL_COL_TOTAL
    };

public:
    explicit JsonTreeModel(QObject *parent = nullptr);
    ~JsonTreeModel() override;
    void clear();
    void hide_value() { showValueCoumn = false; }
    void set_key_name(QString name) { keyHeaderName = name; }
    void set_value_name(QString name) { valueHeaderName = name; }
    bool loadJson(const QJsonObject& obj);
    virtual QVariant data(const QModelIndex &index, int role) const override;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const override;
    QModelIndex index(int row, int column,const QModelIndex &parent = QModelIndex()) const override;
    QModelIndex parent(const QModelIndex &index) const override;
    int rowCount(const QModelIndex &parent = QModelIndex()) const override;
    int columnCount(const QModelIndex &parent = QModelIndex()) const override;

private:
    JsonTreeItem * mRootItem;
    QString keyHeaderName = "Key";
    QString valueHeaderName = "Value";
    bool showValueCoumn = true;
};

#endif // JSONMODEL_H
