/*
**    Copyright 2021 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef MESSAGEPUBLISHER_H
#define MESSAGEPUBLISHER_H

#include <QObject>

class AbstractPublisher;

class MessagePublisher : public QObject
{
    Q_OBJECT
public:
    explicit MessagePublisher(QObject *parent = nullptr);
    static MessagePublisher & instance();
    void pub(const QString &key, const QByteArray &data);

private:

    AbstractPublisher * impl_dummy = nullptr;
    AbstractPublisher * impl_mqtt = nullptr;
    AbstractPublisher * impl_redis = nullptr;
    AbstractPublisher * impl_zmqkv = nullptr;
};

#endif // MESSAGEPUBLISHER_H
