/*
**    Copyright 2022 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef REGIO16CODEC_H
#define REGIO16CODEC_H

#include <QtGlobal>

#include "regiopacket.h"
#include "regop.h"

class QByteArray;

namespace mlink {

class RegOp;
class RegOpVector;

class RegIo16Codec
{
public:
    static bool decode(const PacketData &rx, RegOpVector::iterator first, RegOpVector::iterator last);
    static int encode_regio16_op(const RegOp &op, PacketData *packet);
private:
    static bool encode(const RegOpVector &v, QByteArray &buf);
    static bool decode(const PacketData &buf, RegOpVector &v);
    static quint32 encode_regio16_op(bool read, quint16 addr, quint16 data);
    static int d16Count(const RegOp &op);
};

} // namespace mlink

#endif // REGIO16CODEC_H
