#ifndef ABSTRACTDB_H
#define ABSTRACTDB_H

class QDateTime;
class QJsonObject;
class QString;
template <class Key, class T> class QMap;
template <class T> class QList;

class ConfigSelector;
class ConfigDocument;
class DaqModule;
class ProgramIndex;
class RcRunId;
class ConfigurationName;

class AbstractDB
{
public:
    virtual ~AbstractDB() = default;
    virtual void connectToDb() {}
    virtual ConfigDocument readConfigDocument(const ConfigSelector &cs) = 0;
    virtual bool writeConfigDocument(const ConfigDocument &cd) = 0;
    virtual bool writeConfigRun(const RcRunId &rc, const QJsonObject &jsonCfg) = 0;
    virtual int delete_config(const ConfigSelector &cs) = 0;
    virtual QMap<ProgramIndex, QMap<ConfigurationName, QDateTime> > get_config_map(const DaqModule &daq_module) = 0;
    bool isAlive() const { return alive; }

    bool alive = false;
};

#endif // ABSTRACTDB_H
