/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef BSONQTCONVERTER_H
#define BSONQTCONVERTER_H

#include <QMap>
#include <QString>
#include <QVariant>
#include <QJsonObject>

#ifndef Q_MOC_RUN
#include <bsoncxx/types/value.hpp>
#include <bsoncxx/builder/basic/document.hpp>
#endif

class BsonQtConverter
{
public:
    static QVariant bsoncxx_to_qvariant(const bsoncxx::types::value &value);
    static void append_qvar_to_document(bsoncxx::builder::basic::document &doc_to_return,
                                        const std::string &key,
                                        const QVariant &qvar);

    static bsoncxx::builder::basic::document toDocument(const QVariantMap &m);
    static bsoncxx::builder::basic::array toDocument(const QVariantList &l);
    static QVariantMap fromDocument(const bsoncxx::document::view &doc);

    static bsoncxx::document::value from_json(const QJsonObject &obj);
    static QJsonObject to_json(const bsoncxx::document::view &obj);
};

#endif // BSONQTCONVERTER_H
