/*
**    Copyright 2020 Ilia Slepnev
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "MongoQt_p.h"

#include "mongo_access.h"
#include <mongocxx/instance.hpp>

MongoQtPrivate::MongoQtPrivate(MongoQt *q)
    : q_ptr(q)
{}

bool MongoQtPrivate::configure(const std::string &uri)
{
    return mongo_access::instance().configure(uri);
}

mongocxx::pool::entry MongoQtPrivate::get_connection()
{
    return mongo_access::instance().get_connection();
}

bsoncxx::stdx::optional<mongocxx::pool::entry> MongoQtPrivate::try_get_connection()
{
    return mongo_access::instance().try_get_connection();
}
