#ifndef MULTICASTLISTENER_H
#define MULTICASTLISTENER_H

#include <QHostAddress>
#include <QList>
#include <QMap>
#include <QObject>

class MultiCastListener : public QObject
{
    Q_OBJECT
public:
    explicit MultiCastListener(const QHostAddress &_host, quint16 _port, QObject *parent = nullptr);
    virtual ~MultiCastListener() override;

signals:
    void received(const QByteArray &, const QHostAddress &host);
    void multicastInterfacesUpdated();

private slots:
    void watchInterfaces();

private:
    void startInterface(int index);
    void stopInterface(int index);

    const QHostAddress host;
    const quint16 port;
    // QList<int> activeInterfaces;
    QMap<int, QPointer<QObject> > receivers;
};

#endif // MULTICASTLISTENER_H
