#ifndef PNPDISCOVERY_P_H
#define PNPDISCOVERY_P_H

#include <QElapsedTimer>
#include <QObject>

#include "PnpDiscovery.h"

class PNPServer;
class QTimer;

class PnpDiscoveryPrivate : public QObject
{
    Q_OBJECT
    Q_DECLARE_PUBLIC(PnpDiscovery)

public:
    explicit PnpDiscoveryPrivate(QObject *parent = nullptr);

signals:
    void cacheUpdated(const PnpInfoCache &) const;
    void updateProgramDescription(const ProgramDescription &prog_decsr) const;
    void closeMyProgram(const ProgramDescription &) const;
    void gotProgramClosed(const ProgramDescription &) const;
    void startPnpSearch() const;

private slots:
    void receivedProgramDescription(const ProgramDescription &prog_decsr);
    void receivedProgramClosed(const ProgramDescription &pd);
    void sendUpdates();
    void throttleTimeout();

private:
    void requestUpdate();
    void removeOldDuplicates();

private:
    PnpDiscovery * q_ptr;
    QTimer * const throttleTimer;
    PnpInfoCache pnp_cache;
    QElapsedTimer updateTime;
};

#endif // PNPDISCOVERY_P_H
